type T = int // to allow doing new T[capacity], but can be other type 
 
class{:autocontracts} Stack
{
    const elems: array<T>; 
    var size : nat; // used size
    var capacity: nat;

    ghost predicate Valid()
    reads this
    { size <= capacity == elems.Length
    }
    constructor (cap: nat)
    ensures cap == capacity && size ==0
    {
        elems := new T[cap];
        capacity := cap;
        size := 0; 
    }
 
    predicate  isEmpty()
    {
        size == 0
    }
 
    predicate  isFull()
    {
        size == elems.Length
    }
 
    method push(x : T)
    requires size < capacity
    modifies this, elems
    ensures elems[..size]==old(elems[..size])+[x]
    {
        elems[size] := x;
        size := size + 1;
    }
 
    function   top(): T
    requires size > 0
    {
         elems[size-1]
    }
    
    method  pop() 
    requires size > 0
    modifies this
    ensures elems[..size] == old(elems[..size-1])
    {
         size := size-1;
    }
}
 
// A simple test case.
method {:verify true} Main()
{
    var s := new Stack(3);
    assert s.isEmpty();
    s.push(1);
    s.push(2);
    s.push(3);
    assert s.top() == 3;
    assert s.isFull();
    s.pop();
    assert s.top() == 2;
    print "top = ", s.top(), " \n";
}
