 function Hash(s: string): int {
  SumChars(s) % 137
}

function SumChars(s: string): int {
if |s| == 0 then 0 else
  var last := |s| - 1;
  SumChars(s[..last]) + s[last] as int
}

class ChecksumMachine {
    ghost var data: string
    var cs: int

    ghost predicate Valid()
			reads this
		{ cs == Hash(data) }
		
    constructor ()
    ensures Valid() && data == ""
		{
   data, cs := "", 0;
  }

  function Checksum(): int
   requires Valid()
   reads this
   ensures Checksum() == Hash(data)
  {
   cs
  }
	
    method Append(d: string)
    requires Valid()
    modifies this
    ensures Valid() && data == old(data) + d
    {
        var i := 0;
        while i != |d|
        invariant 0 <= i <= |d|
        invariant Valid()
        invariant data == old(data) + d[..i]
    {
    cs := (cs + d[i] as int) % 137;
    data := data + [d[i]];
    i := i + 1;
}
}
}

method ChecksumMachineTestHarness() {
  var m := new ChecksumMachine();
  m.Append("green");
  m.Append("grass");
  var c := m.Checksum();
  print "Checksum is ", c, "\n";
}



