
type T(==) = int

datatype Tree<T> = Leaf | Node(Tree, T, Tree)

function Contains<T(==)>(t: Tree<T>, v: T): bool
{
match t {
case Leaf => false
case Node(left, x, right) =>
x == v || Contains(left, v) || Contains(right, v) 
}
}

method Fill(t: Tree<T>, a: array<T>, start: int) returns (end: int) 
requires  0 <= start <= a.Length;
decreases t
modifies a;
ensures start <= end <= a.Length;
ensures forall i :: 0 <= i < start ==> a[i] == old(a[i]); 
ensures forall i :: start <= i < end ==> Contains(t, a[i]);
{
match t { 
    case Leaf => end := start;
    case Node(left, x, right) =>
       end := Fill(left, a, start); 
    if end < a.Length {
        a[end] := x;
        end := Fill(right, a, end + 1);
    }
}
}

method Main(){ 
  var q := Node(Node(Leaf,4,Leaf),5, Node(Leaf,3,Leaf));
  var t := new int[10];
  var n := Fill(q,t,0);
  assert Contains(q,3);
  assert t[0] == t[0];
  print t[0], t[1], t[2];
}


