
type T(==) = int

datatype Tree<T> = Leaf  | Node(Tree, T, Tree)

function contains<T(==)>(t: Tree<T>, v: T): bool
{
match t {
case Leaf => false
case Node(left, x, right) =>
x == v || contains(left, v) || contains(right, v) 
}
}
method Fill(t: Tree<T>, a: array<T>, start: int) returns (end: int) 
requires 0 <= start <= a.Length
decreases t
modifies a
ensures  start <= end <= a.Length
ensures forall i:: 0 <= i < start ==> a[i] == old(a[i])
ensures forall i:: start <= i < end ==> contains(t, a[i])
{
match t { 
    case Leaf => end := start;
    case Node(left, x, right) =>
      end := Fill(left, a, start); 
    if end < a.Length {
        a[end] := x;
        end := Fill(right, a, end + 1);
    }
}
}

method Main()
{ var q := Node(Node(Leaf,4,Leaf),5, Node(Leaf,3,Leaf));
  var t := new int[10];
  var n := Fill(q,t,0);
  assert contains(q,3);
  print t[0], t[1], t[2];  
}

